/***********************************************************
	ScreenSaver 02 - Apokalipse

	 2007 A-E Software 
	Arvydas Burdulis
	http://ae.gamedev.lt  aab@auto.lt


	Speed ScreeenSaver

	Pradeta:
	    2008-04-13
	Paskutini karta redaguota:
	    2010-02-17
************************************************************/


#include <windows.h>
#include <math.h>
#include <scrnsave.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <time.h>
#include "Res.h"

static HDC hDC;
static HGLRC hRC;
int x, y;	//Lango dydis

#include "kodas\wgl_arb.hpp"
#include "kodas\matke.hpp"
#include "kodas\tekstas.hpp"
#include "kodas\tga.hpp"
#include "kodas\remas.hpp"
#include "kodas\laikas.hpp"


GLfloat kamera[3] = {0.0, -4.0, 0.8};
GLfloat centras[3] = {0.0, 0.0, 0.4};

GLuint	tekZole,
		tekDangus,
		tekNamas,
		tekLaivas,
		tekPart,
		tekZmogus,
		tekSviesa;

#define NAMU 70
float	namai[NAMU][3];

#include "kodas\zmogus.hpp"
#define ZMONIU 25
KZmogus zmones[ZMONIU];

#include "kodas\laivas.hpp"
#define LAIVU 20
KLaivas laivai[LAIVU];
int laivuIj = 0;



void InitGL(HWND hWnd, HDC & hDC, HGLRC & hRC);
void CloseGL(HWND hWnd, HDC hDC, HGLRC hRC);
void UzkrautiTekst();
GLuint UzkrautiRes(int res);
void Piesti();



LRESULT WINAPI ScreenSaverProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
		//Sukuriamas langas
		case WM_CREATE:
			srand(time(NULL));
			//Inicializuoti OpenGL
			InitGL(hWnd, hDC, hRC);
			//Gauti resource duomenis
			MAKEINTRESOURCE((int)IDC_ICON);
			UzkrautiTekst();
			laikas.Pradeti();
			laikas.Paleisti();
    		return 0;
    	//Naikinamas langas
		case WM_DESTROY:
			CloseGL(hWnd, hDC, hRC);
			return 0;
		//Piesiama scena
		case WM_PAINT:
			laikas.Gauti();
			Piesti();
			SwapBuffers(hDC);
			return true;
		case WM_SIZE:
			glViewport(0, 0, LOWORD(lParam), HIWORD(lParam));
			return 0;
	}

	return DefScreenSaverProc(hWnd, message, wParam, lParam);
}


//Nustatymu dialogas
BOOL WINAPI
ScreenSaverConfigureDialog(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	return true;
}


BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
	return true;
}


// Initialize OpenGL
void InitGL(HWND hWnd, HDC & hDC, HGLRC & hRC)
{
	static	PIXELFORMATDESCRIPTOR pfd=				//pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				//Size Of This Pixel Format Descriptor
		1,											//Version Number
		PFD_DRAW_TO_WINDOW |						//Format Must Support Window
		PFD_SUPPORT_OPENGL |						//Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							//Must Support Double Buffering
		PFD_TYPE_RGBA,								//Request An RGBA Format
		32,											//Bits per pixel
		0, 0, 0, 0, 0, 0,							//Color Bits Ignored
		0,											//No Alpha Buffer
		0,											//Shift Bit Ignored
		0,											//No Accumulation Buffer
		0, 0, 0, 0,									//Accumulation Bits Ignored
		24,											//Z-Buferio gylis
		0,											//No Stencil Buffer
		0,											//No Auxiliary Buffer
		PFD_MAIN_PLANE,								//Main Drawing Layer
		0,											//Reserved
		0, 0, 0										//Layer Masks Ignored
	};

	hDC = GetDC(hWnd);
	int pForm = ChoosePixelFormat(hDC, &pfd);
	SetPixelFormat(hDC, pForm, &pfd);
	hRC = wglCreateContext(hDC);
	wglMakeCurrent(hDC, hRC);
	x = GetSystemMetrics(SM_CXSCREEN);
	y = GetSystemMetrics(SM_CYSCREEN);
    //kadroTrukme = 1.0 / (float)GetDeviceCaps(hDC, VREFRESH);

	//Nustatomi OpenGL parametrai
	glShadeModel(GL_SMOOTH);
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glCullFace(GL_BACK);

	//Klaida("%ix%i %f", x, y, kadroTrukme);
	glViewport(0, 0, x, y);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	//2010-02-17: Ijungti V-Sync
	GLvoid (APIENTRY * wglSwapIntervalEXT)(GLboolean) = (GLvoid (APIENTRY*)(GLboolean)) wglGetProcAddress("wglSwapIntervalEXT");
	if(wglSwapIntervalEXT != NULL)
		wglSwapIntervalEXT(true);
}


//Uzkraunamos teksturos
void UzkrautiTekst()
{
	tekZole = UzkrautiRes(TEKST_ZOLE);
	tekDangus = UzkrautiRes(TEKST_DANGUS);
	tekNamas = UzkrautiRes(TEKST_NAMAS);
	tekLaivas = UzkrautiRes(TEKST_LAIVAS);
	tekPart = UzkrautiRes(TEKST_PART);
	tekZmogus = UzkrautiRes(TEKST_ZMOG);
	tekSviesa = UzkrautiRes(TEKST_SVIES);

	tekstas.Sukurti();

	srand(128);
	for(int i = 0; i < NAMU; i++){
		namai[i][0] = (float)(rand() % 1000) / 200.0 - 2.5;
		namai[i][1] = (float)(rand() % 1000) / 200.0 - 0.5;
		namai[i][2] = 0.6 + ((float)(rand() % 1000) / 1500.0);
	}
	srand(time(NULL));
}


GLuint UzkrautiRes(int res)
{
	HRSRC resas = FindResource(GetModuleHandle(NULL), MAKEINTRESOURCE(res), MAKEINTRESOURCE(IDR_RES_FORM));
	if(resas == NULL){
		//Klaida, nerasti duomenys
		MessageBox(NULL, "Error", "ERROR", MB_OK | MB_ICONERROR);
		return 0;
	}
	HGLOBAL hDuom = LoadResource(NULL, resas);
	if(hDuom == NULL){
		//Klaida, negauti duomenys
		MessageBox(NULL, "Error", "ERROR", MB_OK | MB_ICONERROR);
		return 0;
	}

	unsigned char* duom = (unsigned char *)hDuom;
	if(duom == NULL){
		//Klaida("Klaida gaunant resursa");
		return 0;
	}

	GLuint teks;
	tgaFailas tek;
    try{ tek.Uzkrauti(duom); }
    catch(const char *klaida){
		//Klaida("Klaida uzkraunant tekstura: %s", klaida);
		return 0;
	}

    glGenTextures(1, &teks);
    glBindTexture(GL_TEXTURE_2D, teks);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

    glTexImage2D(GL_TEXTURE_2D, 0, tek.glTipas, tek.x, tek.y, 0, tek.glTipas2, GL_UNSIGNED_BYTE, &duom[18]);
	if(gluBuild2DMipmaps(GL_TEXTURE_2D, tek.glTipas, tek.x, tek.y, tek.glTipas2, GL_UNSIGNED_BYTE, &duom[18]) != 0)
		return 0;

	glBindTexture(GL_TEXTURE_2D, 0);

	if(!glIsTexture(teks)){
		return 0;
	}

	return teks;
}


// Shut down OpenGL
void CloseGL(HWND hWnd, HDC hDC, HGLRC hRC)
{
	wglMakeCurrent(NULL, NULL);
	wglDeleteContext(hRC);
	ReleaseDC(hWnd, hDC);
}


//Piesti scena
void Piesti()
{
	laivuIj = (int)laikas.veikimo;
	if(laivuIj > LAIVU)	laivuIj = LAIVU;
	laivai[rand() % LAIVU].Vogti();
	for(int i = 0; i < laivuIj; i++)
		laivai[i].Atnaujinti();
	for(int i = 0; i < ZMONIU; i++)
		zmones[i].Atnaujinti();

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    //Perspektyvine projekcija
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(35.0f, (float)x / (float)y, 0.01f, 20.0f);		//fovy, aspect, near, far
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
    gluLookAt(kamera[0], kamera[1], kamera[2],	//Kamera
      centras[0], centras[1], centras[2],		//Taikinys
      0.0, 0.0, 1.0);			//Up
    glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
    glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);


    //Dangus
    glBindTexture(GL_TEXTURE_2D, tekDangus);
    glBegin(GL_QUADS);
    	glTexCoord2f(0.0, 0.0);	glVertex3f(-10.0f, 5.0f, 0.0f);
    	glTexCoord2f(4.0, 0.0);	glVertex3f(10.0f, 5.0f, 0.0f);
    	glTexCoord2f(4.0, 1.0);	glVertex3f(10.0f, 5.0f, 5.0f);
    	glTexCoord2f(0.0, 1.0);	glVertex3f(-10.0f, 5.0f, 5.0f);
    glEnd();

    //Zeme
    glBindTexture(GL_TEXTURE_2D, tekZole);
    glBegin(GL_QUADS);
    	glTexCoord2f(0.0, 0.0);		glVertex3f(-10.0f, -5.0f, 0.0f);
    	glTexCoord2f(20.0, 0.0);	glVertex3f(10.0f, -5.0f, 0.0f);
    	glTexCoord2f(20.0, 10.0);	glVertex3f(10.0f, 5.0f, 0.0f);
    	glTexCoord2f(0.0, 10.0);	glVertex3f(-10.0f, 5.0f, 0.0f);
    glEnd();

    //Namai
	glBindTexture(GL_TEXTURE_2D, tekNamas);
	for(int i = 0; i < NAMU; i++){
		glPushMatrix();
		glTranslatef(namai[i][0], namai[i][1], 0.0);
		glScalef(1.0, 1.0, namai[i][2]);
		glBegin(GL_QUADS);
		//Priekine siena
    	glTexCoord2f(0.0, 0.0);	glVertex3f(-0.2f, 0.0f, 0.0f);
    	glTexCoord2f(1.0, 0.0);	glVertex3f(0.2f, 0.0f, 0.0f);
    	glTexCoord2f(1.0, 1.0);	glVertex3f(0.2f, 0.0f, 0.5f);
    	glTexCoord2f(0.0, 1.0);	glVertex3f(-0.2f, 0.0f, 0.5f);
    	//Kaire
    	glTexCoord2f(0.0, 0.0);	glVertex3f(-0.2f, 0.1f, 0.0f);
    	glTexCoord2f(1.0, 0.0);	glVertex3f(-0.2f, 0.0f, 0.0f);
    	glTexCoord2f(1.0, 1.0);	glVertex3f(-0.2f, 0.0f, 0.5f);
    	glTexCoord2f(0.0, 1.0);	glVertex3f(-0.2f, 0.1f, 0.5f);
    	//Desine
    	glTexCoord2f(0.0, 0.0);	glVertex3f(0.2f, 0.0f, 0.0f);
    	glTexCoord2f(1.0, 0.0);	glVertex3f(0.2f, 0.1f, 0.0f);
    	glTexCoord2f(1.0, 1.0);	glVertex3f(0.2f, 0.1f, 0.5f);
    	glTexCoord2f(0.0, 1.0);	glVertex3f(0.2f, 0.0f, 0.5f);
    	//Virsus
    	glTexCoord2f(0.0, 0.75);	glVertex3f(-0.2f, 0.0f, 0.5f);
    	glTexCoord2f(0.25, 0.75);	glVertex3f(0.2f, 0.0f, 0.5f);
    	glTexCoord2f(0.25, 1.0);	glVertex3f(0.2f, 0.1f, 0.5f);
    	glTexCoord2f(0.0, 1.0);		glVertex3f(-0.2f, 0.1f, 0.5f);

    	glEnd();
		glPopMatrix();
	}

	//Laivai
	glDisable(GL_DEPTH_TEST);

	//Zmones
	for(int i = 0; i < ZMONIU; i++)
		zmones[i].Piesti();

	for(int i = 0; i < LAIVU; i++)
		laivai[i].Piesti();

    //Ortografine projekcija
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0, x, 0, y, 1.0, -1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glDisable(GL_TEXTURE_2D);

	remas.Pradeti(5, 5);
    glColor4f(0.0f, 0.0f, 0.0f, 1.0f);
    for(int i = 0; i < 9; i++){
	    if(i == 8)
			glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	    remas.Translate();
	    tekstas.Piesti(" 2008 A-E Software   http://ae.gamedev.lt");
	}

	if(laikas.veikimo < 2.0){
		glDisable(GL_DEPTH_TEST);
		glColor4f(0.0f, 0.0f, 0.0f, 1.0 - (laikas.veikimo / 2.0));
	    glBegin(GL_QUADS);
	    	glVertex3f(0.0f, 0.0f, 0.0f);
	    	glVertex3f(x, 0.0f, 0.0f);
	    	glVertex3f(x, y, 0.0f);
	    	glVertex3f(0.0f, y, 0.0f);
	    glEnd();
	}
}
