KLaivas::KLaivas(): suk(false), vagia(false), zmog(NULL)
{
}


KLaivas::~KLaivas()
{
}


void KLaivas::Vogti()
{
	if(!suk)
		return;
	if(vagia)
		return;
	if(x < -1.0 || x > 1.0)
		return;
	//Patikrinti, ar yra ka vogti
	zmog = NULL;
	for(int i = 0; i < ZMONIU; i++)
		if(zmones[i].x - x > -0.04 && zmones[i].x - x < 0.04 &&
		  zmones[i].y - y > -0.04 && zmones[i].y - y < 0.04){
			zmog = &zmones[i];
			break;
		}
	if(zmog == NULL)
		return;
	//Vogti zmoga!!!
	vagia = true;
	vagiaFaze = 1;
	zmog->vagia = true;
	zmog->tx = zmog->x;
	zmog->ty = zmog->y;
	faze = 0.0;
}


void KLaivas::Atnaujinti()
{
	if(!suk)
		Reset();

	//Atnaujinami particlai
	for(int i = 0; i < 3; i++){
		part[i] += partPlius[i] * laikas.kadro * 10.0;
		if(partPlius[i] > 0.0 && part[i] > 1.0){
			part[i] = 1.0;
			partPlius[i] *= -1.0;
		}
		if(partPlius[i] < 0.0 && part[i] < 0.0){
			part[i] = 0.0;
			partPlius[i] *= -1.0;
		}
	}

	if(vagia){
		faze += laikas.kadro;
		if(vagiaFaze == 1){
			if(faze > 1.0){
				vagiaFaze = 2;
				faze = 0.0;
			}
		}
		if(vagiaFaze == 2){
			zmog->z += 0.005 + faze * 0.02;
			zmog->alpha = 1.0 - (zmog->z / z);
			if(z - zmog->z < 0.2){
				vagiaFaze = 3;
				faze = 0.0;
			}
		}
		if(vagiaFaze == 3){
			zmog->alpha = 0.0;
			if(faze > 1.0){
				vagiaFaze = 0;
				vagia = false;
				zmog->Reset();
			}
		}
		return;
	}

	x += gr * laikas.kadro;
	if(x < -4.1 || x > 4.1)
		Reset();
}


void KLaivas::Piesti()
{
	if(!suk)
		return;
	glPushMatrix();
	glTranslatef(x, y, z);
	//Sviesa
	if(vagia){
		if(vagiaFaze == 1)
			glColor4f(1.0, 1.0, 1.0, faze);
		if(vagiaFaze == 2)
			glColor4f(1.0, 1.0, 1.0, 1.0);
		if(vagiaFaze == 3)
			glColor4f(1.0, 1.0, 1.0, 1.0 - faze);

		glBindTexture(GL_TEXTURE_2D, tekSviesa);
		glBegin(GL_QUADS);
    	glTexCoord2f(0.0, 0.0);	glVertex3f(-0.3f, 0.0f, -z);
    	glTexCoord2f(1.0, 0.0);	glVertex3f(0.3f, 0.0f, -z);
    	glTexCoord2f(1.0, 1.0);	glVertex3f(0.3f, 0.0f, 0.0);
    	glTexCoord2f(0.0, 1.0);	glVertex3f(-0.3f, 0.0f, 0.0);
    	glEnd();
	}
	//Laivas
	glColor4f(1.0, 1.0, 1.0, 1.0);
	glBindTexture(GL_TEXTURE_2D, tekLaivas);
    glBegin(GL_QUADS);
    	glTexCoord2f(0.0, 0.0);	glVertex3f(-0.2f, 0.0f, -0.15f);
    	glTexCoord2f(1.0, 0.0);	glVertex3f(0.2f, 0.0f, -0.15f);
    	glTexCoord2f(1.0, 1.0);	glVertex3f(0.2f, 0.0f, 0.15f);
    	glTexCoord2f(0.0, 1.0);	glVertex3f(-0.2f, 0.0f, 0.15f);
    glEnd();
    //Particlas
    glTranslatef(-0.115, 0.0, -0.042);
    glBindTexture(GL_TEXTURE_2D, tekPart);
    for(int i = 0; i < 3; i++){
		if(i == 0)	glColor4f(1.0, 1.0, 0.0, part[0]);
		if(i == 1)	glColor4f(0.0, 1.0, 0.0, part[1]);
		if(i == 2)	glColor4f(1.0, 0.0, 0.0, part[2]);
	    glBegin(GL_QUADS);
	    	glTexCoord2f(0.0, 0.0);	glVertex3f(-0.05f, 0.0f, -0.05f);
	    	glTexCoord2f(1.0, 0.0);	glVertex3f(0.05f, 0.0f, -0.05f);
	    	glTexCoord2f(1.0, 1.0);	glVertex3f(0.05f, 0.0f, 0.05f);
	    	glTexCoord2f(0.0, 1.0);	glVertex3f(-0.05f, 0.0f, 0.05f);
	    glEnd();
	    glTranslatef(0.12, 0.0, 0.0);
	}
	glPopMatrix();
}


void KLaivas::Reset()
{
	x = 3.0 + ((float)(rand() % 1000) / 1000.0);
	if(rand() % 2)
		x *= -1.0;
	y = ((float)(rand() % 1000)) / 500.0 - 1.0;
	z = ((float)(rand() % 1000)) / 1000.0 + 0.6;
	gr = ((float)(rand() % 1000)) / 1000.0 + 0.05;
	if(x > 0.0)
		gr *= -1.0;

	part[0] = (float)(rand() % 1000) / 1000.0;
	partPlius[2] = partPlius[1] = partPlius[0] = (float)(rand() % 1000) / 1000.0 + 0.02;
	part[1] = part[0] + 0.666;
	if(part[1] > 1.0){
		part[1] = 2.0 - part[1];
		partPlius[1] *= -1.0;
		part[2] = part[1] - 0.666;
		if(part[2] < 0.0)
			part[2] *= -1.0;
		else
			partPlius[2] *= -1.0;
	}
	else{
		part[2] = part[1] + 0.666;
		if(part[2] > 1.0){
			part[2] = 2.0 - part[2];
			partPlius[2] *= -1.0;
		}
	}

	suk = true;
	vagia = false;
}
