//  2007 A-E Software 
// http://ae.dar.lt  aab@auto.lt
//
// TGA lib'as, skirtas TGA paveiksliukams skaityti ir rasyti.
// Palaikomas ir RLE suspaudimas, nepalaikomas tik color index
//
// Liko padaryti: rasyma, RLE
//
// Pradetas:
//      2007-06-25
// Paskutini karta redaguotas:
//      2007-10-20


/*  TGA headeris (18 baitu)
    0-1     unsigned char       id
    1-2     unsigned char       color map type
    2-3     unsigned char       paveiksliuko tipas
    3-5     short int           colour map first entry
    5-7     short int           colour map length
    7-8     unsigned char       map entry size
    9-10    short int           horizontal origin
    10-12   short int           vertical origin
    12-14   short int           plotis
    14-16   short int           aukstis
    16-17   unsigned char       spalvu gylis
    17-18   unsigned char       image descriptor
*/


#ifndef TGA_HPP
#define TGA_HPP

class tgaFailas{
    public:
    unsigned char   header[18]; //Paveiksliuko headeris
    unsigned int    x;          //Paveiksliuko plotis
    unsigned int    y;          //Paveiksliuko aukstis
    unsigned char   bpp;        //Bits per Pixel - spalvu gylis
    unsigned char   tipas;      //Paveiksliuko tipas
    GLuint          glTipas;    //Tipas OpenGL standartais - GL_RGB, GL_RGBA...
    GLuint          glTipas2;   //Antras tipas - GL_BGR, GL_BGRA...
	unsigned int    dataSize;   //data dalies dydis baitais

    tgaFailas();
    ~tgaFailas();
    bool    Uzkrauti(unsigned char*) throw(const char*);
};

#include "tga.cpp"
#endif
