/***********************************************************
	OpenGL extension constants

	 2008 A-E Software 
	Arvydas Burdulis
	http://ae.gamedev.lt  aab@auto.lt


	WGL, OpenGL prapletimu konstantos

	Pradeta:
	    2008-01-31
	Paskutini karta keista:
	    2008-12-04
************************************************************/


#ifndef OGL_EXT_CONSTANTS_HPP
#define OGL_EXT_CONSTANTS_HPP


#define GL_BGR								0x80E0
#define GL_BGRA								0x80E1
#define GL_UNSIGNED_SHORT_1_5_5_5_REV		0x8366
#define GL_TEXTURE0							0x84C0
#define GL_TEXTURE1							0x84C1

//Multisample
#define GL_MULTISAMPLE_ARB					0x809D
#define GL_SAMPLE_BUFFERS_ARB				0x80A8
#define GL_SAMPLES_ARB						0x80A9

//Texture Anisotropic filtering
#define GL_TEXTURE_MAX_ANISOTROPY_EXT		0x84FE
#define GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT	0x84FF

//Cube Map
#define GL_NORMAL_MAP						0x8511
#define GL_REFLECTION_MAP					0x8512
#define GL_TEXTURE_CUBE_MAP					0x8513
#define GL_TEXTURE_BINDING_CUBE_MAP			0x8514
#define GL_TEXTURE_CUBE_MAP_POSITIVE_X		0x8515
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X		0x8516
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y		0x8517
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y		0x8518
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z		0x8519
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z		0x851A
#define GL_PROXY_TEXTURE_CUBE_MAP			0x851B
#define GL_MAX_CUBE_MAP_TEXTURE_SIZE		0x851C

//Seideriai
#define GL_FRAGMENT_SHADER					0x8B30
#define GL_VERTEX_SHADER					0x8B31


//WGL
#define	WGL_NUMBER_PIXEL_FORMATS_ARB		0x2000
#define	WGL_DRAW_TO_WINDOW_ARB				0x2001
#define	WGL_DRAW_TO_BITMAP_ARB				0x2002
#define	WGL_ACCELERATION_ARB				0x2003
#define	WGL_NEED_PALETTE_ARB				0x2004
#define	WGL_NEED_SYSTEM_PALETTE_ARB			0x2005
#define	WGL_SWAP_LAYER_BUFFERS_ARB			0x2006
#define	WGL_SWAP_METHOD_ARB					0x2007
#define	WGL_NUMBER_OVERLAYS_ARB				0x2008
#define	WGL_NUMBER_UNDERLAYS_ARB			0x2009
#define	WGL_TRANSPARENT_ARB					0x200A
#define	WGL_TRANSPARENT_RED_VALUE_ARB		0x2037
#define	WGL_TRANSPARENT_GREEN_VALUE_ARB		0x2038
#define	WGL_TRANSPARENT_BLUE_VALUE_ARB		0x2039
#define	WGL_TRANSPARENT_ALPHA_VALUE_ARB		0x203A
#define	WGL_TRANSPARENT_INDEX_VALUE_ARB		0x203B
#define	WGL_SHARE_DEPTH_ARB					0x200C
#define	WGL_SHARE_STENCIL_ARB				0x200D
#define	WGL_SHARE_ACCUM_ARB					0x200E
#define	WGL_SUPPORT_GDI_ARB					0x200F
#define	WGL_SUPPORT_OPENGL_ARB				0x2010
#define	WGL_DOUBLE_BUFFER_ARB				0x2011
#define	WGL_STEREO_ARB						0x2012
#define	WGL_PIXEL_TYPE_ARB					0x2013
#define	WGL_COLOR_BITS_ARB					0x2014
#define	WGL_RED_BITS_ARB					0x2015
#define	WGL_RED_SHIFT_ARB					0x2016
#define	WGL_GREEN_BITS_ARB					0x2017
#define	WGL_GREEN_SHIFT_ARB					0x2018
#define	WGL_BLUE_BITS_ARB					0x2019
#define	WGL_BLUE_SHIFT_ARB					0x201A
#define	WGL_ALPHA_BITS_ARB					0x201B
#define	WGL_ALPHA_SHIFT_ARB					0x201C
#define	WGL_ACCUM_BITS_ARB					0x201D
#define	WGL_ACCUM_RED_BITS_ARB				0x201E
#define	WGL_ACCUM_GREEN_BITS_ARB			0x201F
#define	WGL_ACCUM_BLUE_BITS_ARB				0x2020
#define	WGL_ACCUM_ALPHA_BITS_ARB			0x2021
#define	WGL_DEPTH_BITS_ARB					0x2022
#define	WGL_STENCIL_BITS_ARB				0x2023
#define	WGL_AUX_BUFFERS_ARB					0x2024

#define	WGL_NO_ACCELERATION_ARB				0x2025
#define	WGL_GENERIC_ACCELERATION_ARB		0x2026
#define	WGL_FULL_ACCELERATION_ARB			0x2027

#define	WGL_SWAP_EXCHANGE_ARB				0x2028
#define	WGL_SWAP_COPY_ARB					0x2029
#define	WGL_SWAP_UNDEFINED_ARB				0x202A

#define	WGL_TYPE_RGBA_ARB					0x202B
#define	WGL_TYPE_COLORINDEX_ARB				0x202C

#define WGL_SAMPLE_BUFFERS_ARB				0x2041
#define WGL_SAMPLES_ARB						0x2042


#endif
